unit KA.Data.KADao.DbSingleLineMemo;

interface

uses
  Borland.Vcl.SysUtils,
  Borland.Vcl.Classes,
  Borland.Vcl.Controls,
  Borland.Vcl.StdCtrls,
  Borland.Vcl.DBCtrls,
  Borland.Vcl.Graphics;

type
  TKADbSingleLineMemo = class(TdbMemo)
  private
    { Private declarations }
    FNumLines : Integer;
    Function     GetLineHeight:Integer;
    Procedure    SetNumLines(Value : Integer);
    Procedure    SetFont(Value : TFont);
    Function     GetFont : TFont;
  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(AOwner: TComponent); Override;
  published
    { Published declarations }
    Property    LineCount : Integer Read FNumLines Write SetNumLines;
    Property    Font      : TFont   Read GetFont Write SetFont;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('KA Dao Controls', [TKADbSingleLineMemo]);
end;

{ TDbSingleLineMemo }


constructor TKADbSingleLineMemo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ScrollBars := ssVertical;
  Height     := GetLineHeight+2;
  WordWrap   := False;
  FNumLines := 1;
end;

procedure TKADbSingleLineMemo.SetNumLines(Value: Integer);
begin
 FNumLines  := Value;
 Height      := (GetLineHeight*FNumLines)+2;
end;

Function TKADbSingleLineMemo.GetLineHeight:Integer;
Var
  Edit : TEdit;                                                                 
Begin
  Edit      := TEdit.Create(Nil);
  Edit.Font := Font;
  Result    := Edit.Height;
  Edit.Free;
End;

Procedure TKADbSingleLineMemo.SetFont(Value : TFont);
Begin
  Inherited Font := Value;
  LineCount      := FNumLines;
End;

Function  TKADbSingleLineMemo.GetFont : TFont;
Begin
 Result := Inherited Font;
End;

end.
